function vexalarm.options.rw.messages.panel()
	local testmsg={
		["buffWtarget"] ={
			["active"] = 	vexalarm.rw.generateText("buffWtarget", select(1, GetSpellInfo(47788)), "47788", "Uberlol", select(1, UnitName("player")), true, frame),
			["inactive"] = 	vexalarm.rw.generateText("buffWtarget", select(1, GetSpellInfo(47788)), "47788", "Uberlol", select(1, UnitName("player")), false, frame),
			},
		["buffWOtarget"] ={
			["active"] = 	vexalarm.rw.generateText("buffWOtarget", select(1, GetSpellInfo(871)), "871", "Uberlol", select(1, UnitName("player")), true, frame),
			["inactive"] = 	vexalarm.rw.generateText("buffWOtarget", select(1, GetSpellInfo(871)), "871", "Uberlol", select(1, UnitName("player")), false, frame),
			},
		["castWtarget"] = 		vexalarm.rw.generateText("castWtarget", select(1, GetSpellInfo(34477)), "34477", "Uberlol", select(1, UnitName("player")), true, frame),
		["castWOtarget"] =	vexalarm.rw.generateText("castWOtarget", select(1, GetSpellInfo(1856)), "1856", "Uberlol", select(1, UnitName("player")), true, frame),
		}

	return {
		type = "group",
		order= 1,
		args = {
			grptestmode = {
				name = "Testmode",
				order=1, type ="group", dialogInline = true,
				args = {
					testmode = {
						name = "Activate",
						order=1, type = "toggle", width="double",
						set = function(info,val) vexalarm.testmode.handler(val) end,
						get = function() return vexalarm.testmode.activated end,
						},
					testmodeinfo = {name = "- Simulates Event outputs. The spell/spell-profile adjustments\nfor the frames are still active.\n- Frames become movable\n- Frames and Outputpositions become recolored", type = "description", order=2, width="double"},
					edit = {name ='\nAny changes will be saved in profile: "|CFF008000'..vexalarm_SV_data["profile"]..'|r"', type = "description", order=5, width="normal"},
					},
				},
			frame_space_testmode = {name ="\n", type = "description", order=2},
			
			grpoptiontabs = {
				name = "Toggle Option Tabs",
				order=3, type ="group", dialogInline = true,
				args = {
					buffs = {
						name = "Buffs with targets",
						order=1, type = "execute",
						func = function(info,val) vexalarm.options.rw.messages.toggleTab("buffs") vexalarm.initialize.core(true) end,
						},
					selfbuffs = {
						name = "Buffs without targets",
						order=2, type = "execute",
						func = function(info,val) vexalarm.options.rw.messages.toggleTab("selfbuffs") vexalarm.initialize.core(true) end,
						},
					space1 = {name =" ", type = "description", order=3},
					instants = {
						name = "Casts with targets",
						order=4, type = "execute",
						func = function(info,val) vexalarm.options.rw.messages.toggleTab("castswithtargets") vexalarm.initialize.core(true) end,
						},
					instantsself = {
						name = "Casts without targets",
						order=5, type = "execute",
						func = function(info,val) vexalarm.options.rw.messages.toggleTab("castswithouttargets") vexalarm.initialize.core(true) end,
						},
					status = {
						name = "[status] messages",
						order=6, type = "execute",
						func = function(info,val) vexalarm.options.rw.messages.toggleTab("status") vexalarm.initialize.core(true) end,
						},
					space = {name =" ", type = "description", order=10},
					Miscellaneous = {
						name = "Miscellaneous",
						order=11, type = "execute",
						func = function(info,val) vexalarm.options.rw.messages.toggleTab("misc") vexalarm.initialize.core(true) end,
						},
					information = {
						name = "HELP",
						order=12, type = "execute",
						func = function(info,val) vexalarm.options.tagWindow.toggle(true) end,
						},
					},
				},
			spaceoptiontabs = {name =" ", type = "description", order=4},
				
			grpmsgsbuffs = {
				name = "Buffs with targets",
				order=10, type ="group", dialogInline = true, hidden = not(vexalarm.options.rw.messages.openTab["buffs"]),
				args = {
					buff = {
						name = "Buff gained",
						order=10, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["buffWtarget"]["active"]=vexalarm.options.frame.messages.filterTags(vexalarm.options.rw.content.killBadTags(val), "buffWtarget") vexalarm.initialize.core(true) end,
						get = function() return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["buffWtarget"]["active"] end
						},
					buffdefault = {
						name = "reset to defaults",
						order=11, type = "execute",
						func = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["buffWtarget"]["active"]=vexalarm.defaults.general["rw"]["msgs"]["buffWtarget"]["active"] vexalarm.initialize.core(true) end,
						},
					example = {name =testmsg["buffWtarget"]["active"], type = "description", order=12,fontSize="medium",},
					buff2 = {
						name = "Buff lost",
						order=21, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["buffWtarget"]["inactive"]=vexalarm.options.frame.messages.filterTags(vexalarm.options.rw.content.killBadTags(val), "buffWtarget") vexalarm.initialize.core(true) end,
						get = function() return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["buffWtarget"]["inactive"] end
						},
					buff2default = {
						name = "reset to defaults",
						order=22, type = "execute",
						func = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["buffWtarget"]["inactive"]=vexalarm.defaults.general["rw"]["msgs"]["buffWtarget"]["inactive"] vexalarm.initialize.core(true) end,
						},
					example2 = {name =testmsg["buffWtarget"]["inactive"], type = "description", order=22,fontSize="medium",},
					colors = {name ="\n\nThe font-colors for raid warnings can't be changed.'", type = "description", order=23,},
					},
				},
				
			grpmsgsselfbuffs = {
				name = "Buffs without targets",
				order=20, type ="group", dialogInline = true, hidden = not(vexalarm.options.rw.messages.openTab["selfbuffs"]),
				args = {
					selfbuff = {
						name = "Buff gained",
						order=10, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["buffWOtarget"]["active"]=vexalarm.options.frame.messages.filterTags(vexalarm.options.rw.content.killBadTags(val), "buffWOtarget") vexalarm.initialize.core(true) end,
						get = function() return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["buffWOtarget"]["active"] end
						},
					selfbuffdefault = {
						name = "reset to defaults",
						order=11, type = "execute",
						func = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["buffWOtarget"]["active"]=vexalarm.defaults.general["rw"]["msgs"]["buffWOtarget"]["active"] vexalarm.initialize.core(true) end,
						},
					example = {name =testmsg["buffWOtarget"]["active"], type = "description", order=12,fontSize="medium",},
					selfbuff2 = {
						name = "Buff lost",
						order=21, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["buffWOtarget"]["inactive"]=vexalarm.options.frame.messages.filterTags(vexalarm.options.rw.content.killBadTags(val), "buffWOtarget") vexalarm.initialize.core(true) end,
						get = function() return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["buffWOtarget"]["inactive"] end
						},
					selfbuff2default = {
						name = "reset to defaults",
						order=22, type = "execute",
						func = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["buffWOtarget"]["inactive"]=vexalarm.defaults.general["rw"]["msgs"]["buffWOtarget"]["inactive"] vexalarm.initialize.core(true) end,
						},
					example2 = {name =testmsg["buffWOtarget"]["inactive"], type = "description", order=22,fontSize="medium",},
					colors = {name ="\n\nThe font-colors for raid warnings can't be changed.'", type = "description", order=23,},
					},
				},
			grpmsgsinstants = {
				name = "Casts with targets",
				order=40, type ="group", dialogInline = true, hidden = not(vexalarm.options.rw.messages.openTab["castswithtargets"]),
				args = {
					castinfo = {name ="Casts that have a target\n", type = "description", order=1, fontSize="medium"},
					castimage = {name=vexalarm.colorize.class(select(1, GetSpellInfo(34477)), "34477", "spell").." (Example)", fontSize="large",
						image = select(3, GetSpellInfo(34477)), type="description", order=2},
					instant = {
						name = "Message",
						order=10, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["castWtarget"]=vexalarm.options.frame.messages.filterTags(vexalarm.options.rw.content.killBadTags(val), "castWtarget") vexalarm.initialize.core(true) end,
						get = function() return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["castWtarget"] end
						},
					instantdefault = {
						name = "reset to defaults",
						order=11, type = "execute",
						func = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["castWtarget"]=vexalarm.defaults.general["rw"]["msgs"]["castWtarget"]vexalarm.initialize.core(true)  end,
						},
					example2 = {name =testmsg["castWtarget"], type = "description", order=22,fontSize="medium",},
					colors = {name ="\n\nThe font-colors for raid warnings can't be changed.'", type = "description", order=23,},
					},
				},
				
			grpmsgsinstantsself = {
				name = "Casts without targets",
				order=50, type ="group", dialogInline = true, hidden = not(vexalarm.options.rw.messages.openTab["castswithouttargets"]),
				args = {
					selfcastinfo = {name ="Casts that have no target and are mostly casted on yourself\n", type = "description", order=1, fontSize="medium"},
					selfcastimage = {name=vexalarm.colorize.class(select(1, GetSpellInfo(1856)), "1856", "spell").." (Example)", fontSize="large",
						image = select(3, GetSpellInfo(1856)), type="description", order=2},
					instantself = {
						name = "Message",
						order=10, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["castWOtarget"]=vexalarm.options.frame.messages.filterTags(vexalarm.options.rw.content.killBadTags(val), "castWOtarget") vexalarm.initialize.core(true) end,
						get = function() return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["castWOtarget"] end
						},
					instantselfdefault = {
						name = "reset to defaults",
						order=11, type = "execute",
						func = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["castWOtarget"]=vexalarm.defaults.general["rw"]["msgs"]["castWOtarget"] vexalarm.initialize.core(true) end,
						},
					example2 = {name =testmsg["castWOtarget"], type = "description", order=22,fontSize="medium",},
					colors = {name ="\n\nThe font-colors for raid warnings can't be changed.'", type = "description", order=23,},
					},
				},
			
			grpmsgsstatus = {
				name = "[status] Messages",
				order=60, type ="group", dialogInline = true, hidden = not(vexalarm.options.rw.messages.openTab["status"]),
				args = {
					statusinfo = {name ="The content of these tags can be adjusted and parsed into the output messages.", type = "description", order=1, fontSize="medium"},
					activeself = {
						name = "[status] active",
						order=10, type = "input", multiline = false,
						set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["status"]["active"]=vexalarm.options.rw.content.killBadTags(val) end,
						get = function() return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["status"]["active"] end
						},
					activedefault = {
						name = "reset to defaults",
						order=11, type = "execute",
						func = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["status"]["active"]=vexalarm.defaults.general["rw"]["msgs"]["status"]["active"] end,
						},
					statusspace = {name ="\n", type = "description", order=12},
						
					inactiveself = {
						name = "[status] inactive",
						order=13, type = "input", multiline = false,
						set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["status"]["inactive"]=vexalarm.options.rw.content.killBadTags(val) end,
						get = function() return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["status"]["inactive"] end
						},
					inactivedefault = {
						name = "reset to defaults",
						order=14, type = "execute",
						func = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["status"]["inactive"]=vexalarm.defaults.general["rw"]["msgs"]["status"]["inactive"] end,
						},
					},
				},
			
			misc = {
				name = "Miscellaneous",
				order=70, type ="group", dialogInline = true, hidden = not(vexalarm.options.rw.messages.openTab["misc"]),
				args = {
					servernames = {
						name = "Don't show servernames in target- and casternames",
						order=1, type = "toggle", width="full", desc="Instead of 'Playername-Servername' only 'Playername' is shown.",
						set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["misc"]["showServer"]=not(val) end,
						get = function() return not(vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["misc"]["showServer"]) end,
						},
					target = {
						name = "Don't show the target when the target is the caster",
						order=2, type = "toggle", width="full", desc="When the target is the caster the addon shows a message for a 'buff without target' or a 'cast without target' instead of a 'buff with target' or a 'cast with target'",
						set = function(info,val) vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["misc"]["showTargetwhenCaster"]=val end,
						get = function() return vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["rw"]["msgs"]["misc"]["showTargetwhenCaster"] end,
						},
					}
				},
			}
		}
end